QwtPlotPicker(3)

NAME
QwtPlotPicker -

SYNOPSIS

Inherits QwtPicker.

Inherited by QwtPlotZoomer.

Detailed Description

QwtPlotPicker provides selections on a plot canvas. QwtPlotPicker is a QwtPicker tailored for selections on a plot canvas. It is set to a x-Axis and y-Axis and translates all pixel coordinates into this coodinate system.

Warning:
    Calling QwtPlot::setAxisScale() while QwtPlot::autoReplot() is FALSE leaves the axis in an 'intermediate' state. In this case, to prevent buggy behaviour, your must call QwtPlot::replot() before calling QwtPlotPicker::scaleRect(), QwtPlotZoomer::scaleRect(), QwtPlotPicker::QwtPlotPicker() or QwtPlotZoomer::QwtPlotZoomer(). This quirk will be removed in a future release.

Definition at line 38 of file qwt_plot_picker.h.

  Signals
void selected (const QwtDoublePoint &pos)
void selected (const QwtDoubleRect &rect)
void selected (const QwtArray< QwtDoublePoint > &pa)
void appended (const QwtDoublePoint &pos)
void moved (const QwtDoublePoint &pos)

  Public Member Functions
QwtPlotPicker (QwtPlotCanvas *, const char *name=0)
QwtPlotPicker (int xAxis, int yAxis, QwtPlotCanvas *, const char *name=0)
QwtPlotPicker (int xAxis, int yAxis, int selectionFlags, RubberBand rubberBand, DisplayMode cursorLabelMode, QwtPlotCanvas *, const char *name=0)
virtual void setAxis (int xAxis, int yAxis)
int xAxis () const
int yAxis () const
QwtPlot * plot ()
const QwtPlot * plot () const
QwtPlotCanvas * canvas ()
const QwtPlotCanvas * canvas () const

  Protected Member Functions
QwtDoubleRect scaleRect () const
QwtDoubleRect invTransform (const QRect &) const
QRect transform (const QwtDoubleRect &) const
QwtDoublePoint invTransform (const QPoint &) const
QPoint transform (const QwtDoublePoint &) const
virtual QString cursorLabel (const QPoint &) const
virtual QString cursorLabel (const QwtDoublePoint &) const
virtual void move (const QPoint &)
virtual void append (const QPoint &)
virtual bool end (bool ok=TRUE)

Constructor & Destructor Documentation

  QwtPlotPicker::QwtPlotPicker (QwtPlotCanvas * canvas, const char * name = 0)

Create a plot picker.

The picker is set to those x- and y-axis of the plot that are enabled. If both or no x-axis are enabled, the picker is set to QwtPlot::xBottom. If both or no y-axis are enabled, it is set to QwtPlot::yLeft.

Parameters:
    canvas Plot canvas to observe, also the parent object
    name Object name

Warning:
    Calling QwtPlot::setAxisScale() while QwtPlot::autoReplot() is FALSE leaves the axis in an 'intermediate' state. In this case, to prevent buggy behaviour, you must call QwtPlot::replot() before calling QwtPlotPicker(). This quirk will be removed in a future release.

See also:
    QwtPlot::autoReplot(), QwtPlot::replot(), QwtPlotPicker::scaleRect()

Definition at line 38 of file qwt_plot_picker.cpp.

References QwtPlot::axisEnabled(), plot(), setAxis(), xAxis(), and yAxis().

  QwtPlotPicker::QwtPlotPicker (int xAxis, int yAxis, QwtPlotCanvas * canvas, const char * name = 0)

Create a plot picker

Parameters:
    xAxis Set the x axis of the picker
    yAxis Set the y axis of the picker
    canvas Plot canvas to observe, also the parent object
    name Object name

Warning:
    Calling QwtPlot::setAxisScale() while QwtPlot::autoReplot() is FALSE leaves the axis in an 'intermediate' state. In this case, to prevent buggy behaviour, you must call QwtPlot::replot() before calling QwtPlotPicker(). This quirk will be removed in a future release.

See also:
    QwtPlot::autoReplot(), QwtPlot::replot(), QwtPlotPicker::scaleRect()

Definition at line 83 of file qwt_plot_picker.cpp.

  QwtPlotPicker::QwtPlotPicker (int xAxis, int yAxis, int selectionFlags, RubberBand rubberBand, DisplayMode cursorLabelMode, QwtPlotCanvas * canvas, const char * name = 0)

Create a plot picker

Parameters:
    xAxis X axis of the picker
    yAxis Y axis of the picker
    selectionFlags Orīd value of SelectionType, RectSelectionType and SelectionMode
    rubberBand Rubberband style
    cursorLabelMode Cursor label mode
    canvas Plot canvas to observe, also the parent object
    name Object name

See also:
    QwtPicker, QwtPicker::setSelectionFlags(), QwtPicker::setRubberBand(), QwtPicker::setCursorLabelMode

Warning:
    Calling QwtPlot::setAxisScale() while QwtPlot::autoReplot() is FALSE leaves the axis in an 'intermediate' state. In this case, to prevent buggy behaviour, you must call QwtPlot::replot() before calling QwtPlotPicker(). This quirk will be removed in a future release.

See also:
    QwtPlot::autoReplot(), QwtPlot::replot(), QwtPlotPicker::scaleRect()

Definition at line 114 of file qwt_plot_picker.cpp.

Member Function Documentation

  void QwtPlotPicker::append (const QPoint & pos) [protected, virtual]

Append a point to the selection and update rubberband and cursor label.

Parameters:
    pos Additional point

See also:
    isActive, begin(), end(), move(), appended()

Note:
    The appended(const QPoint &), appended(const QDoublePoint &) signals are emitted.

Reimplemented from QwtPicker.

Definition at line 261 of file qwt_plot_picker.cpp.

References QwtPicker::append(), appended(), and invTransform().

  void QwtPlotPicker::appended (const QwtDoublePoint & pos) [signal]

A signal emitted when a point has been appended to the selection

Parameters:
    pos Position of the appended point.

See also:
    append(). moved()

Referenced by append().

  const QwtPlotCanvas * QwtPlotPicker::canvas () const

Return Observed plot canvas.

Definition at line 134 of file qwt_plot_picker.cpp.

  QwtPlotCanvas * QwtPlotPicker::canvas ()

Return observed plot canvas.

Definition at line 124 of file qwt_plot_picker.cpp.

References QwtPicker::parentWidget().

Referenced by plot().

  QString QwtPlotPicker::cursorLabel (const QwtDoublePoint & pos) const [protected, virtual]

Translate a position into a position string.

In case of HLineRubberBand the label is the value of the y position, in case of VLineRubberBand the value of the x position. Otherwise the label contains x and y position separated by a ī, ī.

The format for the double to string conversion is '%.4f'.

Parameters:
    pos Position

Returns:
    Position string

Definition at line 238 of file qwt_plot_picker.cpp.

References QwtPicker::rubberBand(), QwtDoublePoint::x(), and QwtDoublePoint::y().

  QString QwtPlotPicker::cursorLabel (const QPoint & pos) const [protected, virtual]

Translate a pixel position into a position string

Parameters:
    pos Position in pixel coordinates

Returns:
    Position string

Reimplemented from QwtPicker.

Definition at line 221 of file qwt_plot_picker.cpp.

References invTransform().

  bool QwtPlotPicker::end (bool ok = TRUE) [protected, virtual]

Close a selection setting the state to inactive.

Parameters:
    ok If TRUE, complete the selection and emit selected signals otherwise discard the selection.

Returns:
    TRUE if the selection is accepted, FALSE otherwise

Reimplemented from QwtPicker.

Reimplemented in QwtPlotZoomer.

Definition at line 290 of file qwt_plot_picker.cpp.

References QwtPicker::end(), invTransform(), plot(), selected(), QwtPicker::selection(), and QwtPicker::selectionFlags().

Referenced by QwtPlotZoomer::end().

  QwtDoublePoint QwtPlotPicker::invTransform (const QPoint & pos) const [protected]

Translate a point from pixel into plot coordinates

Returns:
    Point in plot coordinates

See also:
    QwtPlotPicker::transform()

Definition at line 385 of file qwt_plot_picker.cpp.

References QwtPlot::canvasMap(), QwtDiMap::invTransform(), and plot().

  QwtDoubleRect QwtPlotPicker::invTransform (const QRect & rect) const [protected]

Translate a rectangle from pixel into plot coordinates

Returns:
    Rectangle in plot coordinates

See also:
    QwtPlotPicker::transform()

Definition at line 349 of file qwt_plot_picker.cpp.

References QwtPlot::canvasMap(), QwtDiMap::invTransform(), and plot().

Referenced by append(), cursorLabel(), QwtPlotZoomer::end(), end(), and move().

  void QwtPlotPicker::move (const QPoint & pos) [protected, virtual]

Move the last point of the selection

Parameters:
    pos New position

See also:
    isActive, begin(), end(), append()

Note:
    The moved(const QPoint &), moved(const QDoublePoint &) signals are emitted.

Reimplemented from QwtPicker.

Definition at line 276 of file qwt_plot_picker.cpp.

References invTransform(), QwtPicker::move(), and moved().

  void QwtPlotPicker::moved (const QwtDoublePoint & pos) [signal]

A signal emitted whenever the last appended point of the selection has been moved.

Parameters:
    pos Position of the moved last point of the selection.

See also:
    move(), appended()

Referenced by move().

  const QwtPlot * QwtPlotPicker::plot () const

Return plot widget, containing the observed plot canvas.

Definition at line 154 of file qwt_plot_picker.cpp.

  QwtPlot * QwtPlotPicker::plot ()

Return plot widget, containing the observed plot canvas.

Definition at line 140 of file qwt_plot_picker.cpp.

References canvas().

Referenced by QwtPlotZoomer::end(), end(), invTransform(), QwtPlotZoomer::minZoomSize(), QwtPlotPicker(), QwtPlotZoomer::rescale(), scaleRect(), setAxis(), QwtPlotZoomer::setZoomBase(), and transform().

  QwtDoubleRect QwtPlotPicker::scaleRect () const [protected]

Return normalized bounding rect of the axes

Warning:
    Calling QwtPlot::setAxisScale() while QwtPlot::autoReplot() is FALSE leaves the axis in an 'intermediate' state. In this case, to prevent buggy behaviour, you must call QwtPlot::replot() before calling QwtPlotPicker::scaleRect(). This quirk will be removed in a future release.

See also:
    QwtPlot::autoReplot(), QwtPlot::replot().

Definition at line 170 of file qwt_plot_picker.cpp.

References QwtPlot::axisScale(), QwtScaleDiv::hBound(), QwtScaleDiv::lBound(), plot(), xAxis(), and yAxis().

Referenced by QwtPlotZoomer::rescale(), QwtPlotZoomer::setAxis(), and QwtPlotZoomer::setZoomBase().

  void QwtPlotPicker::selected (const QwtArray< QwtDoublePoint > & pa) [signal]

A signal emitting the selected points, at the end of a selection.

Parameters:
    pa Selected points

  void QwtPlotPicker::selected (const QwtDoubleRect & rect) [signal]

A signal emitted in case of selectionFlags() & RectSelection.

Parameters:
    rect Selected rectangle

  void QwtPlotPicker::selected (const QwtDoublePoint & pos) [signal]

A signal emitted in case of selectionFlags() & PointSelection.

Parameters:
    pos Selected point

Referenced by end().

  void QwtPlotPicker::setAxis (int xAxis, int yAxis) [virtual]

Set the x and y axes of the picker

Parameters:
    xAxis X axis
    yAxis Y axis

Reimplemented in QwtPlotZoomer.

Definition at line 190 of file qwt_plot_picker.cpp.

References plot().

Referenced by QwtPlotPicker(), and QwtPlotZoomer::setAxis().

  QPoint QwtPlotPicker::transform (const QwtDoublePoint & pos) const [protected]

Translate a point from plot into pixel coordinates

Returns:
    Point in pixel coordinates

See also:
    QwtPlotPicker::invTransform()

Definition at line 401 of file qwt_plot_picker.cpp.

References QwtPlot::canvasMap(), plot(), QwtDiMap::transform(), QwtDoublePoint::x(), and QwtDoublePoint::y().

  QRect QwtPlotPicker::transform (const QwtDoubleRect & rect) const [protected]

Translate a rectangle from plot into pixel coordinates

Returns:
    Rectangle in pixel coordinates

See also:
    QwtPlotPicker::invTransform()

Definition at line 367 of file qwt_plot_picker.cpp.

References QwtPlot::canvasMap(), plot(), QwtDiMap::transform(), QwtDoubleRect::x1(), QwtDoubleRect::x2(), QwtDoubleRect::y1(), and QwtDoubleRect::y2().

  int QwtPlotPicker::xAxis () const

Return x axis.

Definition at line 204 of file qwt_plot_picker.cpp.

Referenced by QwtPlotZoomer::minZoomSize(), QwtPlotPicker(), QwtPlotZoomer::rescale(), scaleRect(), and QwtPlotZoomer::setAxis().

  int QwtPlotPicker::yAxis () const

Return y axis.

Definition at line 210 of file qwt_plot_picker.cpp.

Referenced by QwtPlotZoomer::minZoomSize(), QwtPlotPicker(), QwtPlotZoomer::rescale(), scaleRect(), and QwtPlotZoomer::setAxis().

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.